/* $Id: boundary.h,v 1.3 2002/07/26 11:36:06 peteri Exp $ */
#ifndef BOUNDARY_H
#define BOUNDARY_H


#ifdef __cplusplus
extern "C"
{
#endif

#include "mesh.h"

void GetBoundaryRep (MeshGenData *mgds);
void UpdateSplitEdgeToFace(MeshGenData *mgds, Edge *edge);
void UpdateSplitFaceToEdge(MeshGenData *mgds, Face *face);
void SplitBoundaryEdge(MeshGenData *mgds, Edge *edge, Vertex *p);
void SplitBoundaryFace(MeshGenData *mgds, Face *face, Vertex *p);
Edge *InitSplitEdge(Edge *edge, Tos_MStack edgeIter);
Edge *NextSplitEdge(Tos_MStack edgeIter);
Face *InitSplitFace(Face *face, Tos_MStack faceIter);
Face *NextSplitFace(Tos_MStack faceIter);

void PrintFaceMesh(MeshGenData *data);
void PrintEdgeMesh(MeshGenData *data);

#ifdef __cplusplus
}
#endif

#endif /* BOUNDARY_H */

/* Modifications:
 * $Log: boundary.h,v $
 * Revision 1.3  2002/07/26 11:36:06  peteri
 * - nana is removed for simplicity
 * - functions to handle boundary representation, faces, edges, are added
 *
 * Revision 1.2  2002/02/16 18:56:54  romek
 * Doc fix.
 *
 */
