/********************************************************************
 write_dx.h --     
        Functions for writing mesh related data in DX format. 
 
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University Edinburgh    
 ********************************************************************/

/* $Id: write_dx.h,v 1.2 2002/01/31 21:27:59 peteri Exp $ */

#ifndef WRITE_DX_H
#define WRITE_DX_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "mesh.h"

void Tos_OutputOuterSurfaceDX (MeshGenData *mgds);
void Tos_WriteSurfaceMeshDX (MeshGenData *mgds, FILE *filePtr, int surfNum);
void Tos_OutputDXShape (MeshGenData *mgds);
void Tos_WriteMeshAndShapeDataDX (TetrahMesh *tetMesh, FILE *filePtr);

#ifdef __cplusplus
}
#endif


#endif /* WRITE_DX_H */

/* Modifications:
 * $Log: write_dx.h,v $
 * Revision 1.2  2002/01/31 21:27:59  peteri
 * Major reorganization in the code.
 * - It is split into smaller modules.
 * - Some types, functions are renamed
 * - Proper flipping of edges is implemented
 *
 * Revision 1.1.1.1  2002/01/30 10:20:55  peteri
 * Imported using TkCVS
 *
 * Revision 1.1  2001/10/27 18:31:57  romek
 * Initial revision
 *
 */
