/********************************************************************
  nurbs_supp.c 
            NURBSCURVE interface routines 
 
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University Edinburgh    
 ********************************************************************/

 /* $Id: nurbs_supp.h,v 1.1.1.1 2002/08/04 13:19:11 peteri Exp $ */

#ifndef _NURBS_SUPP_H
#define _NURBS_SUPP_H

#include "e_lib.h" /* for NURBSCURVE */

/* Allocate memory for NURBSCURVE structure. */
NURBSCURVE* RP_InitNurbs ();

/* Allocate memory for members of NURBSSURVE structure. */ 
void RP_EmptyNurbs (NURBSCURVE *nurbs, int degree);

/* Free memory allocated for NURBSCURVE members. */
void RP_CleanNurbs (NURBSCURVE *nurbs);

/* Free memory allocated for NURBSCURVE structure. */
/* If needed free memory allocated for members of NURBSCURVE. */
void RP_FreeNurbs (NURBSCURVE *nurbs);


#endif /* _NURBS_SUPP_H */

/* Modifications:
 * $Log: nurbs_supp.h,v $
 * Revision 1.1.1.1  2002/08/04 13:19:11  peteri
 * Imported using TkCVS
 *
 */ 
