# all.tcl --
#

if {[lsearch [namespace children] ::tcltest] == -1} {
    package require tcltest
    namespace import ::tcltest::*
}

set etliVersion [package require Etli]
set ::tcltest::testSingleFile false 
set ::tcltest::testsDirectory [file dir [info script]]

puts stdout "Etli $etliVersion tests running in interp:  [info nameofexecutable]"
puts stdout "Tests running in working dir:  $::tcltest::testsDirectory"
if {[llength $::tcltest::skip] > 0} {
    puts stdout "Skipping tests that match:  $::tcltest::skip"
}
if {[llength $::tcltest::match] > 0} {
    puts stdout "Only running tests that match:  $::tcltest::match"
}

if {[llength $::tcltest::skipFiles] > 0} {
    puts stdout "Skipping test files that match:  $::tcltest::skipFiles"
}
if {[llength $::tcltest::matchFiles] > 0} {
    puts stdout "Only sourcing test files that match:  $::tcltest::matchFiles"
}

set testTimer {clock format [clock seconds]}
puts stdout "Tests started at [eval $testTimer]"

# source each of the specified tests
foreach file [lsort [::tcltest::getMatchingFiles]] {
    set basename [file tail $file]
    puts stdout $basename
    if {[catch {source $file} msg]} {
	puts stdout $msg
    }
}

# cleanup
puts stdout "\nTests finished at [eval $testTimer]"
::tcltest::cleanupTests 1
return

