/********************************************************************
 test_RP_MeshElementNodes.c
       Test program for RP_MeshElementType function; 
 
 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University Edinburgh    
 ********************************************************************/

/* $Id: test_RP_MeshElemType.c,v 1.1.1.1 2002/08/04 13:19:11 peteri Exp $ */

#include "e_lib.h"
#include "mesh_supp.h"

/* By standard convention main returns:
 * 0 if all tests pass
 * 1 if any of test fails - additional information is printed on stderr
 * 77 if tests should be skipped
 */ 
int main()
{
  MESH *mesh;
  int elem, i, elemType; 

  int result=0;
  
  /* read mesh composed of TRIANG1 elements */
  e_GetMeshData (&mesh, "b_square_tr1");   

  /* finnd element type (should be 5) */
  elem = 1;
  elemType = RP_MeshElementType (mesh, elem); 
  if (elemType != 5) 
    {
     fprintf (stderr, "test_RP_MehsElemType-1.1 : element type\n");  
     fprintf (stderr, "Result was: %d\n", elemType);  
     fprintf (stderr, "Result should be: 5\n");  
     result = 1; 
    }
  elem = 5;  /* in mesh wy have only 4 elements: should return -1 */
  elemType = RP_MeshElementType (mesh, elem); 
  if (elemType != -1)
    {
     fprintf (stderr, "test_RP_MehsElemType-1.2 : wrong elemtnt number\n");  
     fprintf (stderr, "Result was: %d\n", elemType);  
     fprintf (stderr, "Result should be: -1\n");  
     result = 1;
    } 
  elem = 0; /* should return -1; elements are numbered from 0 */
  elemType = RP_MeshElementType (mesh, elem); 
  if (elemType != -1)
    {
     fprintf (stderr, "test_RP_MehsElemType-1.3: wrong elemtnt number\n");  
     fprintf (stderr, "Result was: %d\n", elemType);  
     fprintf (stderr, "Result should be: -1\n");  
     result = 1;
    }
  return result;
}
    
/* Modifications:
 * $Log: test_RP_MeshElemType.c,v $
 * Revision 1.1.1.1  2002/08/04 13:19:11  peteri
 * Imported using TkCVS
 *
 */ 
            
