/* all information related to the background mesh */

#ifndef BG_DATA_H__
#define BG_DATA_H__

#include "e_lib.h"
#include "mgni.h"
#include "mtrf.h"

#define NODEMPRSET  0
#define ELEMMPRSET  1

typedef struct 
{
  int			  bgnp;				/* no. of points */
  double  **bgcoords;		/* point coordinates */
  int 		  bgntr;			/* no. of triangles */
  int 		**bgtr;				/* the triangle matrix */
  double	 *bgmpr;			/* mesh parameters */
  int			  bgwmpr;			/* which kind of mprs (NODEMPRSET,ELEMMPRSET) */
  PARAMCNTLSETS *pcs;		/* the local control sources */
}
BG_DATA;

void get_bg_data(BG_DATA **bgd, MESH *bgmesh, PARAMCNTLSETS *pcs);
                
void free_bg_data(BG_DATA *bgd);

double get_bg_mpr(BG_DATA *bgd, double *pnt, int ctrl, MTRF *mtrf);

#endif


