#include "mgni.h"
#include "dtr.h"

int e_2D_triangulate(double ***coords, int *nn, BND *bnd,
                     int ***triangles, MTRF *mtrf)
{
  int **tpnl;                   /* triangle per node listing */

  int *hull;                    /* the convex hull */
  int nh;                       /* number of points in the hull */
  int ntr;                      /* the number of triangles in tr */
  int ttr;                      /* the allocated space in the triangle matrix */
  int **tr;                     /* the triangle matrix of the convex domain */
  int ntriangles;               /* the real number of triangles */
  int tp;                       /* allocated space in coords matrix */

  int nnp;                      /* number of new nodes due to stitching */
  int stnp;                     /* starting number of stiched nodes */

  int t, s;                     /* counters */

  /* initialization */
  tpnl = NULL;
  inittpnl(&tpnl, *nn);
  hull = NULL;

  /* the main triangulation */

  f_connect_bnd_nodes(*coords, *nn, bnd, &tr, &ntr, &hull, &nh, tpnl, mtrf);

  ttr = ntr;
  tp = *nn;
  stnp = *nn;

  nnp = recover_boundaries(coords, nn, &tp, &stnp, tr, ntr, &tpnl, bnd,
                           CTRL_UNIFORM, NULL, mtrf);

  while (nnp > 0)
  {
    add_new_nodes(*coords, *nn, nnp, stnp, &tr, &ntr, &ttr,
                  &hull, &nh, tpnl, mtrf);

    nnp = recover_boundaries(coords, nn, &tp, &stnp, tr, ntr, &tpnl, bnd,
                             CTRL_UNIFORM, NULL, mtrf);
  }

  setareacode(bnd, tpnl, tr, ntr);

  /* freeing up */
  e_free(hull);
  freetpnl(tpnl, *nn);

  /* output */
  ntriangles = 0;
  for (t = 0; t < ntr; t++)
    if (tr[t][10] != -1)
      ntriangles++;
  (*triangles) = e_alloc_cont_i_matr(ntriangles, 11);
  ntriangles = 0;
  for (t = 0; t < ntr; t++)
    if (tr[t][10] != -1)
    {
      for (s = 0; s < 3; s++)
        (*triangles)[ntriangles][s] = tr[t][s];
 (*triangles)[ntriangles][10]=1;
      ntriangles++;
    }

  e_free_cont_i_matr(ttr, tr);

  return ntriangles;
}
