#include "getvertices.h"

void e_GetElementVertices(int ElemIndex, MESH *mesh, 
                          int *NVertices, int **Vertices)
{
  int selected_elem_node;

  (*NVertices) = -1;
  (*Vertices) = NULL;

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_LINK1]
     && mesh->FirstNetIndex[E_ELEM_TYPE_LINK1] <= (ElemIndex+1) )
  {
    (*NVertices) = 2;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_LINK1];
    if(selected_elem_node < mesh->NElemsLink1)
      (*Vertices) = mesh->NodesLink1[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_LINK2]
     && mesh->FirstNetIndex[E_ELEM_TYPE_LINK2] <= (ElemIndex+1) )
  {
    (*NVertices) = 2;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_LINK2];
    if(selected_elem_node < mesh->NElemsLink2)
      (*Vertices) = mesh->NodesLink2[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_LINK3]
     && mesh->FirstNetIndex[E_ELEM_TYPE_LINK3] <= (ElemIndex+1) )
  {
    (*NVertices) = 2;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_LINK3];
    if(selected_elem_node < mesh->NElemsLink3)
      (*Vertices) = mesh->NodesLink3[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_LINK4]
     && mesh->FirstNetIndex[E_ELEM_TYPE_LINK4] <= (ElemIndex+1) )
  {
    (*NVertices) = 2;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_LINK4];
    if(selected_elem_node < mesh->NElemsLink4)
      (*Vertices) = mesh->NodesLink4[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_LINK5]
     && mesh->FirstNetIndex[E_ELEM_TYPE_LINK5] <= (ElemIndex+1) )
  {
    (*NVertices) = 2;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_LINK5];
    if(selected_elem_node < mesh->NElemsLink5)
      (*Vertices) = mesh->NodesLink5[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG1]
     && mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG1] <= (ElemIndex+1) )
  {
    (*NVertices) = 3;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG1];
    if(selected_elem_node < mesh->NElemsTriang1)
      (*Vertices) = mesh->NodesTriang1[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG2]
     && mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG2] <= (ElemIndex+1) )
  {
    (*NVertices) = 6;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG2];
    if(selected_elem_node < mesh->NElemsTriang2)
      (*Vertices) = mesh->NodesTriang2[selected_elem_node];
  }

  if(    mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG3]
     &&  mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG3] <= (ElemIndex+1) )
  {
    (*NVertices) = 3;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG3];
    if(selected_elem_node < mesh->NElemsTriang3)
      (*Vertices) = mesh->NodesTriang3[selected_elem_node];
  }

  if(    mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG4]
     &&  mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG4] <= (ElemIndex+1) )
  {
    (*NVertices) = 3;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG4];
    if(selected_elem_node < mesh->NElemsTriang4)
      (*Vertices) = mesh->NodesTriang4[selected_elem_node];
  }

  if(    mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG5]
     &&  mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG5] <= (ElemIndex+1) )
  {
    (*NVertices) = 3;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TRIANG5];
    if(selected_elem_node < mesh->NElemsTriang5)
      (*Vertices) = mesh->NodesTriang5[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_QUAD1]
     && mesh->FirstNetIndex[E_ELEM_TYPE_QUAD1] <= (ElemIndex+1) )
  {
    (*NVertices) = 4;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_QUAD1];
    if(selected_elem_node < mesh->NElemsQuad1)
      (*Vertices) = mesh->NodesQuad1[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_QUAD3]
     && mesh->FirstNetIndex[E_ELEM_TYPE_QUAD3] <= (ElemIndex+1) )
  {
    (*NVertices) = 9;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_QUAD3];
    if(selected_elem_node < mesh->NElemsQuad3)
      (*Vertices) = mesh->NodesQuad3[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_TETRAH1]
     && mesh->FirstNetIndex[E_ELEM_TYPE_TETRAH1] <= (ElemIndex+1) )
  {
    (*NVertices) = 4;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_TETRAH1];
    if(selected_elem_node < mesh->NElemsTetrah1)
      (*Vertices) = mesh->NodesTetrah1[selected_elem_node];
  }

  if(   mesh->FirstNetIndex[E_ELEM_TYPE_BLOCK1]
     && mesh->FirstNetIndex[E_ELEM_TYPE_BLOCK1] <= (ElemIndex+1) )
  {
    (*NVertices) = 8;
    selected_elem_node = ElemIndex + 
                         1 - mesh->FirstNetIndex[E_ELEM_TYPE_BLOCK1];
    if(selected_elem_node < mesh->NElemsBlock1)
      (*Vertices) = mesh->NodesBlock1[selected_elem_node];
  }

}







