#ifndef WIN32
#include <sys/time.h>
#else
#include <time.h>
#endif

#define TIMING_C
#include "timing.h"
#undef TIMING_C

#ifdef WIN32
long p_GetTime(void)
{
   clock_t tnow;
   tnow=clock();
   return( tnow );
}
#endif

#ifndef WIN32
long p_GetTime(void)
{
   struct timeval tv;
   struct timezone tz;
   gettimeofday( &tv, &tz );
   return( tv.tv_usec/1000+tv.tv_sec*1000 );
}
#endif

void p_StartTimer()
{
  timerStart = p_GetTime();
}

long p_Timer()
{
  return ( p_GetTime() - timerStart );
}
