#include "mgn.h"
#include "mgn_graphics.h"
#include "dtr.h"
#include "nodelem.h"
#include "boundary.h"
#include "mgn_aux.h"

/*#define  OLD_BND_RECOV*/

#if 0
/* this is the old boundary detection function.
   it was scrapped in favour of the more general boundary detection
   function in common/boundary.c */
int setupbnd(int **tr, int ntr, int fh, int **tpnl, BND *bnd)
{
  /* this function initializes and fills in the boundary
   * information structure.
   * for the outer edge it starts a search at the first point of the
   * convex hull: fh.
   * for the inner edges (holes) it looks for any other triangles
   * with a side without neighbours.
   * this function returns 1 in case of success. anything else in case
   * of failure.
   */

  /* the only slight change from the generally used definition
     for the bnd struct is that I use node indices and not node numbers ! */

  int i, t, s;                  /* counters */
  int *trs;                     /* mark each triangle that is used in the outer
                                   edge search, so that it is not used again for
                                   an inner edge search */
  int closed;                   /* true if the edge is closed */
  int undetectedholesleft;      /* explains itself, doesn't it? */
  int firsttr;                  /* the first triangle of a hole */

  trs = e_alloc_i_vect(ntr);
  for (i = 0; i < ntr; i++)
    if ((tr[i][3] == -1) || (tr[i][4] == -1) || (tr[i][5] == -1))
      trs[i] = 1;               /* triangle with at least one edge side and not used in the outer edge */
    else
      trs[i] = 0;               /* inner triangle or used in outer edge */
  bnd->oe.nen = 1;
  bnd->oe.en = e_alloc_i_vect(EDGE_INCR);
  bnd->oe.en[0] = fh;           /* start the edge */
  closed = FALSE;
  while (!closed)
  {
    for (t = 0; t < tpnl[bnd->oe.en[bnd->oe.nen - 1]][0]; t++)
    {
      for (s = 0; s < 3; s++)
        if (tr[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]][s] ==
            bnd->oe.en[bnd->oe.nen - 1])
          break;
      if (s == 3)
        e_GeneralError("tpnl is corrupted\n");
      if (tr[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]][3 + s] == -1)
        break;
    }
    if (t == tpnl[bnd->oe.en[bnd->oe.nen - 1]][0])
      e_GeneralError("more corruption found, alas\n");

    /* check whether the boundary is closed */
    if (tr[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]][(s + 1) % 3] ==
        bnd->oe.en[0])
    {
      trs[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]] = 0;
      closed = TRUE;
    }
    else
    {
      /* make more space if necessary */
      bnd->oe.en = e_incr_i_vect(bnd->oe.nen, bnd->oe.en, EDGE_INCR);
      /*  and add the new entry to the edge vector */
      bnd->oe.en[bnd->oe.nen] =
        tr[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]][(s + 1) % 3];
      /* mark the used triangle */
      trs[tpnl[bnd->oe.en[bnd->oe.nen - 1]][2 + t]] = 0;
      bnd->oe.nen++;
    }
  }

  /* and do the same for the holes */
  bnd->nie = 0;
  bnd->ie = NULL;
  undetectedholesleft = FALSE;
  for (i = 0; i < ntr; i++)
    if (trs[i] == 1)
    {
      undetectedholesleft = TRUE;
      break;
    }
  while (undetectedholesleft)
  {
    bnd->ie = incr_edge_vect(bnd->nie, bnd->ie, 1);
    firsttr = i;
    for (s = 0; s < 3; s++)
      if (tr[firsttr][3 + s] == -1)
        break;
    trs[firsttr] = 0;
    bnd->ie[bnd->nie].nen = 2;
    bnd->ie[bnd->nie].en = e_alloc_i_vect(EDGE_INCR);
    bnd->ie[bnd->nie].en[0] = tr[firsttr][s];
    bnd->ie[bnd->nie].en[1] = tr[firsttr][(s + 1) % 3];
    closed = FALSE;
    while (!closed)
    {
      for (t = 0;
           t < tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][0]; t++)
      {
        for (s = 0; s < 3; s++)
          if (tr[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]]
              [s] == bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1])
            break;
        if (s == 3)
          e_GeneralError("tpnl is corrupted\n");
        if (tr[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]]
            [3 + s] == -1)
          break;
      }
      if (t == tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][0])
        e_GeneralError("more corruption found, alas\n");
      if (tr[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]]
          [(s + 1) % 3] == bnd->ie[bnd->nie].en[0])
      {
        trs[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]] = 0;
        closed = TRUE;
      }
      else
      {
        bnd->ie[bnd->nie].en = e_incr_i_vect(bnd->ie[bnd->nie].nen,
                                             bnd->ie[bnd->nie].en, EDGE_INCR);
        bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen] =
          tr[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]][(s
                                                                            +
                                                                            1)
                                                                           %
                                                                           3];
        trs[tpnl[bnd->ie[bnd->nie].en[bnd->ie[bnd->nie].nen - 1]][2 + t]] = 0;
        bnd->ie[bnd->nie].nen++;
      }
    }
    bnd->nie++;
    undetectedholesleft = FALSE;
    for (i = 0; i < ntr; i++)
      if (trs[i] == 1)
      {
        undetectedholesleft = TRUE;
        break;
      }
  }

  e_free(trs);
  return 1;
}

EDGE *incr_edge_vect(unsigned int length, EDGE * vector,
                     unsigned int LengthIncrem)
{
  /* memory allocation function used in setupbnd */
  EDGE *newvect;
  int e;

  newvect = (EDGE *) e_calloc(length + LengthIncrem, sizeof(EDGE));
  memcpy(newvect, vector, length * sizeof(EDGE));
  for (e = length; e < length + LengthIncrem; e++)
  {
    newvect[e].nen = 0;
    newvect[e].en = NULL;
  }
  return newvect;
}
#endif

void setup_2D_bnd(MESH *mesh, BND **bnd)
{
  /* wrapper for the common boundary detection procedure */
  int *NoNodeElem;		/* node-element connectivity */
  int **NodeElem;     /* equivalent to tpnl */
  int nb;							/* number of boundaries */
  int e, i;						/* counters */

  /* establish node-element connectivity */
  NoNodeElem = e_alloc_i_vect(mesh->NMeshPoints);
  NodeElem = e_init_frag_i_matr(mesh->NMeshPoints);
  e_InitMeshPointElemConnection(mesh, NoNodeElem, NodeElem);

  /* generate the boundary structure */
  Gen2DBoundary(mesh, NoNodeElem, NodeElem, &nb, bnd);

  /* check */
  if (nb != 1)
    e_GeneralError("this mesh generator works only for single domain coarse meshes");

  /* switch node numbering base from 1 to 0 */
  for (i=0;i<(*bnd)->oe.nen;i++)
    (*bnd)->oe.en[i]--;
  for (e=0;e<(*bnd)->nie;e++)
    for (i=0;i<(*bnd)->ie[e].nen;i++)
      (*bnd)->ie[e].en[i]--;

  /* free-up */
  e_free(NoNodeElem);
  e_free_frag_i_matr(mesh->NMeshPoints, NodeElem);
}

int recover_bnd_by_swap(double ***coords, int *np, int *tp,
                        int *stnp, int **tr, int ntr, int ***tpnl,
                        BND *bnd, int ctrltype, double **crsnmpr,
                        MTRF *mtrf)
{
  int b, e;                     /* counters */
  int nd;                       /* the first node of a boundary segment */
  int nx;                       /* the second node of a boundary segment */
  int nswaps=0;

  (*stnp) = (*np);

  /* first checking the outer edge */
  for (b = 0; b < bnd->oe.nen; b++)
  {
    nd = bnd->oe.en[b];
    nx = bnd->oe.en[(b + 1) % bnd->oe.nen];
    check_and_swap_edge(*coords, *np, tr, ntr, nd, nx, *tpnl, mtrf, &nswaps);
  }
  /* then checking of the holes */
  for (e = 0; e < bnd->nie; e++)
    for (b = 0; b < bnd->ie[e].nen; b++)
    {
      nd = bnd->ie[e].en[b];
      nx = bnd->ie[e].en[(b + 1) % bnd->ie[e].nen];
      check_and_swap_edge(*coords, *np, tr, ntr, nd, nx, *tpnl, mtrf, &nswaps);
    }

  /* for compatibility with ordinary bnd recovery by halfwaynodes */
  return 0;
}

void check_and_swap_edge(double **coords, int np, int **tr, int ntr, int nd,
                         int nx, int **tpnl, MTRF *mtrf, int *nswaps)
{
  int ct, nt;                   /* current and next triangle */
  int t;                        /* triangle counter in tpnl */
  int s;                        /* side counter */
  int nxreached;                /* rather obvious isn't it */
  int s1, s2;                   /* nodes */
  int ccw1,ccw2;
  int valid1,valid2;

  if (tpnl[nd][0] == 0)
    e_GeneralError("check_and_swap_edge: the tpnl is corrupted");
  if (!edgechecked(tpnl, tr, nd, nx))
  {
    nxreached = FALSE;
    while (!nxreached)
    {
      for (t = 0; t < tpnl[nd][0]; t++)
      {
        for (s = 0; s < 3; s++)
          if (nd == tr[tpnl[nd][2 + t]][s])
          {
            s1 = tr[tpnl[nd][2 + t]][(s + 1) % 3];
            s2 = tr[tpnl[nd][2 + t]][(s + 2) % 3];
            break;
          }
        /* if ((s1==nx)||(s2==nx))
           nxreached=TRUE; */
        ccw1=IsCCW(coords[nd], coords[s1], coords[nx], mtrf, &valid1);
        ccw2=IsCCW(coords[nd], coords[nx], coords[s2], mtrf, &valid2);
        if (ccw1 && ccw2 && valid1 && valid2)
          break;
      }
      if (t == tpnl[nd][0])
        e_GeneralError("check_and_swap_edge: nx cannot be reached");
      ct = tpnl[nd][2 + t];
      nt = tr[ct][3 + (s + 1) % 3];
      swap2triangles(tr, ct, nt, tpnl);
      if (ShowGraphics)
      {
        mgnDrawAll(np, coords, ntr, tr, 0, NULL, 0, NULL, NULL, "after swap");
      }
      (*nswaps)++;
      if (PrintProgress)
        printf("boundary recovery by swapping: %d\n",*nswaps);
      if (tr[ct][0] == nx)
        nxreached = TRUE;
    }
  }
}

void swap2triangles(int **tr, int t1, int t2, int **tpnl)
{
  /* swap the common diagonal between t1 and t2 */
  /* the new t1 and t2 will have the common diagonal as first side */

  int s1, s2;                   /* side indicators */
  int n11, n12, n13;            /* the three nodes of t1 starting at first common node */
  int n21, n22, n23;            /* the three nodes of t2 starting at first common node */
  int k;                        /* counter */
  int rp1[10], rp2[10];         /* triangle entries */

  for (s1 = 0; s1 < 3; s1++)
  {
    for (s2 = 0; s2 < 3; s2++)
      if ((tr[t1][s1] == tr[t2][(s2 + 1) % 3])
          && (tr[t1][(s1 + 1) % 3] == tr[t2][s2]))
        break;
    if (s2 < 3)
      break;
  }
  if (s1 == 3)
    e_GeneralError("swap2triangles: can't find comon diagonal");

  n11 = tr[t1][s1];
  n12 = tr[t1][(s1 + 1) % 3];
  n13 = tr[t1][(s1 + 2) % 3];
  n21 = tr[t2][s2];
  n22 = tr[t2][(s2 + 1) % 3];
  n23 = tr[t2][(s2 + 2) % 3];

  if ((n11 != n22) || (n12 != n21))
    e_GeneralError("swap2triangles: sanity count failed");

  /* duplicating the triangle entries */
  for (k = 0; k < 10; k++)
  {
    rp1[k] = tr[t1][k];
    rp2[k] = tr[t2][k];
  }

  /* and swapping */
  tr[t1][0] = n23;
  tr[t2][0] = n13;
  tr[t1][1] = n13;
  tr[t2][1] = n23;
  tr[t1][2] = n11;
  tr[t2][2] = n12;
  tr[t1][3] = t2;
  tr[t2][3] = t1;
  tr[t1][4] = rp1[3 + (s1 + 2) % 3];
  tr[t2][4] = rp2[3 + (s2 + 2) % 3];
  tr[t1][5] = rp2[3 + (s2 + 1) % 3];
  tr[t2][5] = rp1[3 + (s1 + 1) % 3];
  tr[t1][6] = 3;
  tr[t2][6] = 3;
  tr[t1][7] = rp1[6 + (s1 + 2) % 3];
  tr[t2][7] = rp2[6 + (s2 + 2) % 3];
  tr[t1][8] = rp2[6 + (s2 + 1) % 3];
  tr[t2][8] = rp1[6 + (s1 + 1) % 3];
  tr[t1][9] = 1;
  tr[t2][9] = 1;
  tr[t1][10] = 0;
  tr[t2][10] = 0;
  if (tr[t1][4] != -1)
    tr[tr[t1][4]][tr[t1][7]] = t1;
  if (tr[t1][5] != -1)
    tr[tr[t1][5]][tr[t1][8]] = t1;
  if (tr[t1][4] != -1)
    tr[tr[t1][4]][3 + tr[t1][7]] = 4;
  if (tr[t1][5] != -1)
    tr[tr[t1][5]][3 + tr[t1][8]] = 5;
  if (tr[t2][4] != -1)
    tr[tr[t2][4]][tr[t2][7]] = t2;
  if (tr[t2][5] != -1)
    tr[tr[t2][5]][tr[t2][8]] = t2;
  if (tr[t2][4] != -1)
    tr[tr[t2][4]][3 + tr[t2][7]] = 4;
  if (tr[t2][5] != -1)
    tr[tr[t2][5]][3 + tr[t2][8]] = 5;

  /* updating the tpnl */
  rmvtrftpnlist(t1, n12, tpnl);
  rmvtrftpnlist(t2, n11, tpnl);
  addtr2tpnlist(tr, t1, tpnl);
  addtr2tpnlist(tr, t2, tpnl);
}

int recover_boundaries(double ***coords, int *np, int *tp,
                       int *stnp, int **tr, int ntr, int ***tpnl,
                       BND *bnd, int ctrltype, double **crsnmpr,
                       MTRF *mtrf)
{

#ifndef OLD_BND_RECOV

  return recover_bnd_by_swap(coords, np, tp, stnp, tr, ntr,
                             tpnl, bnd, ctrltype, crsnmpr, mtrf);

#else
  /* this function checks for boundaries which are not in the
   * current triangulation. if any are found half distance points are
   * generated. these are inserted into the coords array.
   *
   * the bnd is updated and the number of new points is returned
   */

  int nnp;                      /* number of new points generated */
  int b, e, i;                  /* counter */
  int nd;                       /* the considered node */
  int nxnd;                     /* the next node on the edge */

  nnp = 0;
  (*stnp) = (*np);

  /* first checking the outer edge */
  for (b = 0; b < bnd->oe.nen; b++)
  {
    nd = bnd->oe.en[b];
    nxnd = bnd->oe.en[(b + 1) % bnd->oe.nen];
    if ((*tpnl)[nd][0] == 0)
      e_GeneralError("the tpnl is corrupted\n");
    if (!edgechecked((*tpnl), tr, nd, nxnd))
    {
      /* edge is not in triangulation, so recover it */
      makehalfwaynode(coords, np, tp, nd, nxnd, tpnl, ctrltype, crsnmpr);
      bnd->oe.en = e_incr_i_vect(bnd->oe.nen, bnd->oe.en, EDGE_INCR);
      for (i = bnd->oe.nen; i > b; i--)
        bnd->oe.en[i + 1] = bnd->oe.en[i];
      bnd->oe.en[b + 1] = (*np) - 1;
      bnd->oe.nen++;
      b++;
      nnp++;
    }
  }

  /* then checking the inner edges */
  for (e = 0; e < bnd->nie; e++)
    for (b = 0; b < bnd->ie[e].nen; b++)
    {
      nd = bnd->ie[e].en[b];
      nxnd = bnd->ie[e].en[(b + 1) % bnd->ie[e].nen];
      if ((*tpnl)[nd][0] == 0)
        e_GeneralError("the tpnl is corrupted\n");
      if (!edgechecked((*tpnl), tr, nd, nxnd))
      {
        /* edge is not in triangulation, so recover it */
        makehalfwaynode(coords, np, tp, nd, nxnd, tpnl, ctrltype, crsnmpr);
        bnd->ie[e].en =
          e_incr_i_vect(bnd->ie[e].nen, bnd->ie[e].en, EDGE_INCR);
        for (i = bnd->ie[e].nen; i > b; i--)
          bnd->ie[e].en[i + 1] = bnd->ie[e].en[i];
        bnd->ie[e].en[b + 1] = (*np) - 1;
        bnd->ie[e].nen++;
        b++;
        nnp++;
      }
    }

  /* and return the number of new points ! */
  return nnp;
#endif
}

int edgechecked(int **tpnl, int **triangles, int nd, int nxnd)
{
  int recover;                  /* the edge needs to be recovered */
  int t, s;                     /* counters */

  recover = TRUE;
  for (t = 0; t < tpnl[nd][0]; t++)
  {
    for (s = 0; s < 3; s++)
    {
      if (triangles[tpnl[nd][2 + t]][s] == nxnd)
      {
        recover = FALSE;
        break;
      }
    }
    if (!recover)
      break;
  }
  return (!recover);
}

void makehalfwaynode(double ***coords, int *np, int *tp,
                     int nd, int nxnd, int ***tpnl, int ctrltype,
                     double **crsnmpr)
{
  if ((*tp) - (*np) < 1)
  {
    (*coords) = e_ext_cont_d_matr((*tp), 3, (*coords), 1);
    (*tpnl) = e_ext_frag_i_matr((*tp), (*tpnl), 1);
    if (ctrltype == CTRL_MPR)
      (*crsnmpr) = e_ext_d_vect((*tp), (*crsnmpr), 1);
    (*tp)++;
  }
  if (ctrltype == CTRL_MPR)
    (*crsnmpr)[(*np)] = ((*crsnmpr)[nd] + (*crsnmpr)[nxnd]) / 2;
  (*coords)[(*np)][0] = ((*coords)[nd][0] + (*coords)[nxnd][0]) / 2;
  (*coords)[(*np)][1] = ((*coords)[nd][1] + (*coords)[nxnd][1]) / 2;
  (*coords)[(*np)][2] = ((*coords)[nd][2] + (*coords)[nxnd][2]) / 2;;
  (*tpnl)[(*np)] = e_alloc_i_vect(2);
  (*tpnl)[(*np)][0] = 0;
  (*tpnl)[(*np)][1] = 0;
  (*np)++;
}

void setareacode(BND * bnd, int **tpnl, int **tr, int ntr)
{
  /* this function sets the triangle areacode in the triangle matrix
   * this is index [10]. values are:
   *   +1 triangle belongs to main domain
   *   -1 triangle belongs not to the domain (holes or inconvex domain shapes)
   *   0  areacode has'n t been set
   * triangles with code -1 can't be refined nor flipped
   * but they are kept for the trianglesearch routine.
   */

  int b, e, s, t;               /* counter */
  int lt, rt;                   /* the left triangle and the right triangle */
  int a;                        /* answer of the leftandrighttr function */
  int cont;                     /* continue searching */

  /* first set the areacodes for all triangles near edges */
  for (b = 0; b < bnd->oe.nen; b++)
  {
    a =
      leftandrighttr(tr, tpnl, bnd->oe.en[b],
                     bnd->oe.en[(b + 1) % bnd->oe.nen], &lt, &rt);
    if (a == 0)
      e_GeneralError("tpnl got corrupted\n");
    else if (a == 1)
      tr[lt][10] = +1;
    else if (a == 2)
      e_GeneralError("bnd got corrupted\n");
    else                        /* (a==3) */
    {
      tr[lt][10] = +1;
      tr[rt][10] = -1;
    }
  }
  for (e = 0; e < bnd->nie; e++)
    for (b = 0; b < bnd->ie[e].nen; b++)
    {
      a =
        leftandrighttr(tr, tpnl, bnd->ie[e].en[b],
                       bnd->ie[e].en[(b + 1) % bnd->ie[e].nen], &lt, &rt);
      if (a == 0)
        e_GeneralError("tpnl got corrupted\n");
      else if (a == 1)
        tr[lt][10] = +1;
      else if (a == 2)
        e_GeneralError("bnd got corrupted\n");
      else                      /* (a==3) */
      {
        tr[lt][10] = +1;
        tr[rt][10] = -1;
      }
    }

  /* then fill in all other areacodes
   * this is easiest done by filling in the -1's first
   * the remaining 0's are then +1's for sure
   */
  cont = TRUE;
  while (cont)                  /* while 0's left in the outside area */
  {
    cont = FALSE;               /* assume no such 0's */
    for (t = 0; t < ntr; t++)   /* check all triangles */
      if (tr[t][10] == -1)      /* so far discovered outside triangles only */
        for (s = 0; s < 3; s++) /* check all three sides */
          if (tr[t][3 + s] != -1) /* find a side on which this one has a neighbour */
            if (tr[tr[t][3 + s]][10] == 0) /* if the neighbour is undetermined yet */
            {
              tr[tr[t][3 + s]][10] = -1; /* then make it a recognized outside triangle */
              if (!cont)        /* if you haven't discovered any other 0's yet */
                for (e = 0; e < 3; e++) /* check all three sides of this newly recognized triangle */
                  if (tr[tr[t][3 + s]][e + 3] != -1) /* to see if it has a neighbour */
                    if (tr[tr[tr[t][3 + s]][e + 3]][10] == 0) /* that is not determined */
                      cont = TRUE; /* you've found a 0 to set in the next step */
            }
  }

  /* out of domain triangles which haven't been set to -1
   * definitely have an already -1 triangle as neighbour.
   */

  /* fill in all remaining 0's as +1's */
  for (t = 0; t < ntr; t++)
    if (tr[t][10] == 0)
      tr[t][10] = +1;
}

int leftandrighttr(int **tr, int **tpnl, int fn, int sn, int *lt, int *rt)
{
  /* this function determines the triangles on the left and the right
   * of the edge defined by first node fn and second node sn.
   * return codes are:
   *  0 = no triangles were found (should not happen)
   *  1 = only a left triangle was found
   *  2 = only a right triangle was found
   *  3 = both left and right triangles were found
   */

  int t, tx, i;                 /* counter */
  int c1, c2;                   /* the triangles on either side of an edge */

  c1 = -1;
  c2 = -1;
  for (t = 0; t < tpnl[fn][0]; t++)
    for (tx = 0; tx < tpnl[sn][0]; tx++)
      if (tpnl[fn][2 + t] == tpnl[sn][2 + tx])
      {
        if (c1 == -1)
          c1 = tpnl[fn][2 + t];
        else
          c2 = tpnl[fn][2 + t];
      }
  if (c1 == -1)
    return 0;
  for (i = 0; i < 3; i++)
    if (tr[c1][i] == fn)
      break;
  if (i == 3)
    e_GeneralError("the tpnl is corrupted\n");
  if (tr[c1][(i + 1) % 3] == sn)
  {
    (*lt) = c1;
    if (c2 != -1)
    {
      (*rt) = c2;
      return 3;
    }
    else
      return 1;
  }
  else
  {
    (*rt) = c1;
    if (c2 != -1)
    {
      (*lt) = c2;
      return 3;
    }
    else
      return 2;
  }
}

/* end of file */
