#ifndef RGR_H
#define RGR_H

#include "e_lib.h"
#include "mgni.h"

/*** rgr method options **/
#define RECOVERY_BY_SWAPPING		TRUE
#define USE_STAR								TRUE
#define USE_BND_ALIGN						TRUE
#define USE_OLD_DLN							FALSE
#define USE_PROJ_ALIGN					FALSE

/* rgr_grid.c */
int make_grid_points(double ***coords, int *np, int *tp,
                     int *stnp, double **mpr,
                     int ***tpnl,
                     double gprm, double umpr,
                     double **fcoords, int fnp, int **ftr, int fntr);
void include_grid_node(double pos[2], double ***coords, int *np, int *tp,
                       double **mpr, int *nnp, int ***tpnl, double nmpr);

/* rgr_refine.c */
int simple_refine(double ***coords, int *np, int *tp,
                  int *stnp, double **mpr, int **tr, int ntr,
                  int ***tpnl, double rprm, int proj);
int simple_dual_refine(double ***coords, int *np, int *tp,
                       int *stnp, double **mpr, int **tr, int ntr,
                       int ***tpnl, double rprm, int use_star);

/* rgr_bnd.c */
void make_fake_boundary_nodes(double ***fcoords, int *fnp, BND *bnd,
                              double umpr, int geomset, MESH *mesh);
void copy_bnd(BND *source, BND *target);
#ifdef OUT_OF_DATE
int make_aligned_boundary_nodes(double ***coords, int *np, int *tp, int *stnp,
                                double **mpr, BND *bnd,
                                int ***tpnl, double gprm, double umpr);
#endif
int make_aligned_boundary_nodes_incl_nurbs(double ***coords, int *np, int *tp,
                                           int *stnp, double **mpr, BND *bnd,
                                           int ***tpnl, double gprm,
                                           double umpr, int geomset,
                                           MESH *mesh);
void adjust_curve_refine_output(int *nsp, double **seg_crd);

/* rgr_align.c */
int new_algn_bnd_nodes(double ***coords, int *np, int *tp, int *stnp,
                       double **mpr, BND *bnd, int ***tpnl, double gprm,
                       double umpr, int geomset, MESH *mesh, int ngn);

#endif

