# -- EnterDebugTagsMode --
# 
# Initialte mode for debuging objects tags.
#
# Arguments:
#    NONE
# Results:
#    Returns NULL.
#    Before entering zoom mode enters the default mode.
#    Sets mode name and initialtes window zooming bindings.
# Calls:
#    EnterDefaultMode, MakeDebugTagsBindings
#
proc EnterDebugTagsMode {} {
    global drawArea

    EnterDefaultMode
    set drawArea(mode) "DebugTags"
    set drawArea(modefun) MakeDebugTagsBindings
    MakeDebugTagsBindings
    return  
} 

# -- BreakDebugTagsMode --
#
# Terminates the debuging tags mode
#
# Arguments:
#   NONE
# Results:
#   Returns NULL
#   Enters the default mode
# Calls:
#   EnterDefaultMode
#
proc BreakDebugTagsMode {} {
    EnterDefaultMode
}

# -- MakeDebugTagsBindings --
#
# Sets bindings for mouse events related to debug tags mode
#
# Arguments:
#   NONE
# Results:
#   Returns NULL.
# Calls:
#   EnterDefaultMode, PrintTags   
#
proc MakeDebugTagsBindings {} {
    global drawArea

    bind $drawArea(cv) <ButtonPress-1> {
        set x1 [expr %x - $drawArea(searchwidth)]
        set x2 [expr %x + $drawArea(searchwidth)]
        set y1 [expr %y - $drawArea(searchheight)]
        set y2 [expr %y + $drawArea(searchheight)]
        set items [$drawArea(cv) find overlapping $x1 $y1 $x2 $y2]
        puts $items 
        if { [llength $items] > 0} then {
            puts "[llength $items] items sellected" 
            foreach item $items {
                 puts "  > [GetTags $item]"
                 puts "     > coords [GetCoords $item]"
            }
        } else {
            puts "Nothing sellected"
        }
    }
    bind $drawArea(cv) <ButtonPress-3> {
        BreakDebugTagsMode        
    }
    return        
}
#EOF
