proc SetGlobals {} {
    global drawArea
    global Nurbs
    global Mesh
    global Entries

    global zoomMode
    global ImageProp

    global XcursorOldPos
    global YcursorOldPos 

   
    set XcursorOldPos 0
    set YcursorOldPos 0

    set  zoomMode(x) 0 
    set  zoomMode(y) 0
    set  zoomMode(active) 0
    set  zoomMode(regioncoords) {}
    set  zoomMode(unzoomed) 1

#application global settings
    set drawArea(currentbasename) "noname"
    set drawArea(currentpath) [pwd]
#image support
    set drawArea(baseimage) {}
    set drawArea(currentimage) {}
# zoom region 
    set drawArea(zoomRegionRatio)  3
    set drawArea(currentRegionCol) 1
    set drawArea(currentRegionRow) 1
    set drawArea(regionHeight) {}
    set drawArea(regionWidth) {}  

#drawArea global settings
    set drawArea(region) {0.0 0.0 500.0 433.0}
    set drawArea(view) {0.0 0.0 500.0 433.0}
    set drawArea(limits) {0.0 0.0 500.0 433.0}
    set drawArea(canv) {0 0 500 433}
    set drawArea(width) 500
    set drawArea(height) 433 
# coordinates transformatio coefficient
    set drawArea(trans) 0.0
# limits coordinate transformation coefficient
    set drawArea(inittrans) 0.0
# current position in canvas coordinates
    set drawArea(pos) {0 0}
    set drawArea(origin) {0 0}
    set drawArea(unitchange)  60    
    set drawArea(xsnap) 1 
    set drawArea(ysnap) 1 
    set drawArea(mode) "None"
    set drawArea(ctwidth) 15
    set drawArea(ctprec) 4
    set drawArea(coordText) [format "x=%-*.*f y=%-*.*f" $drawArea(ctwidth) \
              $drawArea(ctprec) 0.0 $drawArea(ctwidth) $drawArea(ctprec) 0.0]
    set drawArea(searchwidth) 5
    set drawArea(searchheight) 5
#   node x offset
    set drawArea(ntxo) 4     
#   node y offset
    set drawArea(ntyo) 4   
#   node text font
    set fontSize [option get . NumbersFontSize NumbersFontSize]

    set drawArea(tfont) "-family times -size $fontSize"
    set drawArea(nradius) [option get . MeshNodeSize MeshNodeSize]    
    set drawArea(linkwidth) [option get . LinkElemWidth LinkElemWidth]
    set drawArea(modefun) "DefaultBindings"
    set drawArea(currentpanel) {}
    set drawArea(showaxes) 1

    set drawArea(numberscolor) [option get . NumbersColor NumbersColor]
    set drawArea(elcolor) [option get . PlanarElementColor PlanarElementColor]
    set drawArea(elemoutline) [option get . ElementOutlineColor \
                     ElementOutlineColor]
    set drawArea(ncolor)  [option get . MeshNodeColor MeshNodeColor]
    set drawArea(bg) [option get . BackgroundColor BackgroundColor]
    set drawArea(linkcolor) [option get . LinkElementColor LinkElementColor]
    set drawArea(axescolor) [option get . AxesColor AxesColor]
    set drawArea(nodeselectcolor) [option get . ActiveMeshNodeColor \
                                     ActiveMeshNodeColor]

    set Nurbs(lcolor) [option get . NurbsColor NurbsColor] 
    set Nurbs(ncurcolor) [option get . NurbsNodeColor NurbsNodeColor]
    set Nurbs(nbasecolor) [option get . NurbsBaseColor NurbsBaseColor]
    set Nurbs(scolor) [option get  . NurbsSkeletonColor NurbsSkeletonColor]

#   mesh global settings
    set Mesh(nnodes) 0
    set Mesh(nelems2) 0
    set Mesh(nelems3) 0
    set Mesh(nelems4) 0
    set Mesh(totnelems) 0
    set Mesh(basename) "simple"
    set Mesh(nvertex) 3
    set Mesh(Nodes2) {}
    set Mesh(Nodes3) {}
    set Mesh(Nodes4) {}
    set Mesh(nodecoords) {}
# list of list of nurbs attached to nodes
    set Mesh(nodenurbs) {}
    set Mesh(nvertex) -1
    set Mesh(nodemeshparam) {}
    set Mesh(selnodnum) {} 
    set Mesh(selnodes) {}
    set Mesh(shownodes) 1
    set Mesh(shownodesnum) 1
    set Mesh(showelems) 1
    set Mesh(showelemsnum) 1

#Nurbs global settings
    set Nurbs(nnodes) 0
    set Nurbs(def) {}
    set Nurbs(skel) {}
    set Nurbs(ntotal) 0
    set Nurbs(nradius) [option get . NurbsNodeSize NurbsNodeSize]   
    set Nurbs(nurbswidth) [option get . NurbsLineWidth NurbsLineWidth]
    set Nurbs(id) 0 
    set Nurbs(shownodes) 1
    set Nurbs(showskel) 1
    set Nurbs(shownnum) 0
    set Nurbs(showbase) 1
    set Nurbs(shownodesnum) 0
    set Nurbs(curnurbs) -1
    set Nurbs(curnode) -1
    set Nurbs(numoffset) 6
    set Nurbs(startNode) 0
    set Nurbs(endNode) 0
    set Nurbs(showbase) 1  
    set Nurbs(nurbslist) {}

    set drawArea(trans) [CalcTransform] 
    set drawArea(inittrans) $drawArea(trans)

    set Entries(nodenum) 0
    set Entries(nurbsnum) 0
    set Entries(xcoord) 0
    set Entries(ycoord) 0
    set Entries(meshparam) 0
    set Entries(weight) 0
    set Entries(xlow) 0
    set Entries(ylow) 0
    set Entries(xhigh) 0
    set Entries(yhigh) 0
    set Entries(region) 0

    set ImageProp(xins) 0
    set ImageProp(yins) $drawArea(height) 
    set ImageProp(xdisp) 0
    set ImageProp(ydisp) 0
    set ImageProp(anchor) sw



    return 
}    

proc dupa { a b c} {
  puts "$a $b $c"
 
}
proc Reload {} {
source bindings.tcl
source draw.tcl
source globals.tcl
source nurbs.tcl
source transform.tcl
source utils.tcl
source widgets.tcl
}
# EOF
