proc LoadImage  {} {
     ReadImage
     DrawImage
    .nvMain.special.m entryconfigure 2 -state normal 
    .nvMain.zoom.m entryconfigure 1 -state disabled

}

proc RemoveImage {} {
    global drawArea
  
    $drawArea(cv) delete IMAGE

    if {$drawArea(baseimage) != ""} {
       image delete $drawArea(baseimage)
       image delete $drawArea(currentimage)
       set drawArea(baseimage) {}
       set drawArea(currentimage) {}
    }
    .nvMain.special.m entryconfigure 1 -state normal 
    .nvMain.special.m entryconfigure 2 -state disabled 
    .nvMain.zoom.m entryconfigure 1 -state normal 

}

proc ReadImage {} {
    global drawArea 
    global Mesh
    set types {
        {{GIF} {.gif}}
        {{PPM} {.ppm}}
        {{PGM} {.ppm}}
        {{All files} {*}}
    }

    set filename [tk_getOpenFile -initialdir $drawArea(currentpath) \
               -filetypes $types]

    if {$filename  != ""} {
    set drawArea(baseimage) [image create photo -file $filename]
    set drawArea(currentimage) [image create photo] 
    $drawArea(currentimage) copy $drawArea(baseimage)   

    }
}

proc DrawImage {} {
    global drawArea
    global ImageProp
    global zoomMode
    if {$drawArea(baseimage) != ""} { 
       if {$zoomMode(unzoomed) == 1} {
          $drawArea(cv) create image $ImageProp(xins) $ImageProp(yins)  \
                 -anchor $ImageProp(anchor) -image \
                  $drawArea(currentimage)  -tag IMAGE
          $drawArea(cv) lower IMAGE
       } else {
          $drawArea(cv) create image $ImageProp(xdisp) $ImageProp(ydisp) \
                  -anchor  $ImageProp(anchor) -image \
                 $drawArea(currentimage)  -tag IMAGE
          $drawArea(cv) lower IMAGE
       }
    }
}

proc ZoomRegionImage {xl yl xh yh} {
    global drawArea
    global zoomMode
    global ImageProp
 
#    set ImageProp(xdisp) 0
#    set ImageProp(ydisp) $drawArea(height) 
    if {$drawArea(baseimage) != ""} {
        set xl [expr int(floor($xl))]
        set yl [expr int(floor($yl))]
        set xh [expr int(ceil($xh))]
        set yh [expr int(ceil($yh))]

        set imageheight [image height $drawArea(currentimage)]
        set imagewidth  [image width  $drawArea(currentimage)]

        set yl [expr $yl + $imageheight - $drawArea(height)]
        set yh [expr $yh + $imageheight - $drawArea(height)]

        if {$xl > $imagewidth || $yh < 0} {
             $drawArea(cv) delete IMAGE
             $drawArea(currentimage) blank
            return 
        }

# partial cover of image by region window
        if {$xh > $imagewidth} {
           set xh $imagewidth
        }
        if {$yl < 0 } {
           set yl 0
        }



        set img [image create photo]

        $img copy $drawArea(currentimage) -from $xl $yl $xh $yh \
                -zoom $drawArea(zoomRegionRatio) 

        puts "$img copy $drawArea(currentimage) -from $xl $yl $xh $yh -zoom $drawArea(zoomRegionRatio) "
        $drawArea(cv) delete IMAGE
        image delete $drawArea(currentimage)
        set drawArea(currentimage) $img
puts "$drawArea(cv) create image $ImageProp(xdisp) $ImageProp(ydisp) " 
        $drawArea(cv) create image $ImageProp(xdisp) $ImageProp(ydisp)  \
            -anchor $ImageProp(anchor)  -image \
            $drawArea(currentimage)  -tag IMAGE
        $drawArea(cv) lower IMAGE
        set zoomMode(unzoomed) 0
    }
}

proc ZoomLimitsRegionImage {} {
    global drawArea
    global zoomMode
    global ImageProp
    if {$drawArea(baseimage) != ""} {
        $drawArea(cv) delete IMAGE
        image delete $drawArea(currentimage)
        set drawArea(currentimage) [image create photo] 
        $drawArea(currentimage) copy $drawArea(baseimage)   
               $drawArea(cv) create image $ImageProp(xins) $ImageProp(yins) \
               -anchor $ImageProp(anchor) -image \
                $drawArea(currentimage)  -tag IMAGE
        $drawArea(cv) lower IMAGE
        set zoomMode(unzoomed) 1
    }
}
#EOF
