proc OpenNewFile {} {
    DeleteMesh
    DeleteAllNurbs
    CleanCanvas
    EnterDefaultMode
    ReadModuleMdf
}

proc ReadModuleMdf {} {
    global drawArea 
    global Mesh
    set types {
        {{Elib geometry file} {.mdf}}
        {{All files} {*}}
    }

    set filename [tk_getOpenFile -initialdir $drawArea(currentpath) \
               -filetypes $types]

    if {$filename  != ""} {
       set extension [file extension $filename]
       if { [string compare $extension ".mdf"] == 0} {
          set basename  [string range $filename 0 end-4]
       } else {
          set basename $filename
       }
         
        set drawArea(currentpath) [file dirname $filename]
        set drawArea(currentbasename) [file tail $basename]
        ReadMdf [file join $drawArea(currentpath) $basename]
        set Mesh(shownodes) 0
        set Mesh(shownodesnum) 0
        set Mesh(showelemsnum) 0
        RedrawMesh
    }
}

proc ReadModuleGmf {} {
    global drawArea 
    global Mesh
    set types {
        {{Elib geometry file} {.gmf}}
        {{All files} {*}}
    }

    set filename [tk_getOpenFile -initialdir $drawArea(currentpath) \
               -filetypes $types]

    if {$filename  != ""} {
       set extension [file extension $filename]
       if { [string compare $extension ".gmf"] == 0} {
          set basename  [string range $filename 0 end-4]
       } else {
          set basename $filename
       }
         
        set drawArea(currentpath) [file dirname $filename]
        set drawArea(currentbasename) [file tail $basename]
        ReadGmf [file join $drawArea(currentpath) $basename]
        RedrawNurbs
    }
}


# Export mesh in mdf format
proc SaveModuleMdf {} {
    global drawArea 
    set types {
        {{Elib geometry file} {.mdf}}
        {{All files} {*}}
    }
    set filename [tk_getSaveFile -initialdir $drawArea(currentpath) \
                -initialfile $drawArea(currentbasename).mdf \
                -filetypes $types]

    if {$filename  != ""} {
       set extension [file extension $filename]
       if { [string compare $extension ".mdf"] == 0} {
          set basename  [string range $filename 0 end-4]
       } else {
          set basename $filename
       }
        set drawArea(currentpath) [file dirname $filename]
        set drawArea(currentbasename) [file tail $basename]
        SaveMdf [file join $drawArea(currentpath) $basename]
    }
}

proc SaveModuleGmf {} {
    global drawArea

    set types {
        {{Elib geometry file} {.gmf}}
        {{All files} {*}}
    }
    set filename [tk_getSaveFile -initialdir $drawArea(currentpath) \
                -initialfile $drawArea(currentbasename).gmf \
                -filetypes $types]

    if {$filename  != ""} {
       set extension [file extension $filename]
       if { [string compare $extension ".gmf"] == 0} {
          set basename  [string range $filename 0 end-4]
       } else {
          set basename $filename
       }
        set drawArea(currentpath) [file dirname $filename]
        set drawArea(currentbasename) [file tail $basename]
        SaveGmf [file join $drawArea(currentpath) $basename]
    }
}

proc SaveModuleMpr {} {
    CommandNotImplemented
}

proc SaveModuleDom {} {
    CommandNotImplemented
}


proc UpdateMesh {} {
  global Mesh
  global drawArea

  # append the element nodes numbers to the appropriate list
  lappend Mesh(Nodes$Mesh(nvertex)) $Mesh(selnodnum) 
  return
}


# procedure: NeAdjacencyCreate
proc NeAdjacencyCreate {} {
   global Mesh
   for { set i 0 } { $i < $Mesh(nnodes) } {incr i} {
       lappend Mesh(neAdjacency) [list 0]
   }
   puts $Mesh(neAdjacency)
   set i 1    
   foreach elem $Mesh(Nodes2) {
       foreach node $elem {
           set n [expr $node -1]
           set nadj [lindex $Mesh(neAdjacency) $n]
           set ne [lindex $nadj 0]
           incr ne
           set nadj [lreplace $nadj 0 0 $ne]
           lappend nadj $i
           set Mesh(neAdjacency) [lreplace $Mesh(neAdjacency) $n $n $nadj] 
       }
       incr i
   }

}
#EOF
